//
// Programma che utilizza le classi Deque, Stack e Queue; prima versione.
//


#include <iostream.h>
#include "Deque1.H"


main()
{
  Queue q1(4);
  Queue q2;
  Stack p1(7);
  Stack p2;
  Deque d1(10);
  Deque d2;


  // Operazioni sulle Queue.
  q1.Enqueue(12);
  q1.Enqueue(16);
  q1.Enqueue(13);
  q1.Enqueue(15);

  cout << "La testa della Coda q1 e` " << q1.Read() << endl;
  cout << "Rimuovo la testa di q1 " << q1.Dequeue() << endl;
  cout << "La testa della Coda q1 e` " << q1.Read() << endl;

  if (q2.IsEmpty())
    cout << "La Coda q2 e` vuota." << endl;
  else {
    mytype testa = q2.Dequeue();
    cout << "La testa di q2 era: " << testa << endl;
  }

  // Operazioni sugli Stack.
  p1.Push(12);
  p1.Push(16);

  cout << "La testa della Pila p1 e` " << p1.Read() << endl;
  cout << "Rimuovo la testa di p1 " << p1.Pop() << endl;
  cout << "La testa della Pila p1 e` " << p1.Read() << endl;

  if (p2.IsEmpty())
    cout << "La Pila p2 e` vuota." << endl;
  else {
    mytype testa = p2.Pop();
    cout << "La testa di p2 era: " << testa << endl;
  }

  // Operazioni sulle Deque.
  d1.InsertHead(12);
  d1.InsertHead(16);
  d1.InsertTail(13);
  d1.InsertHead(15);

  cout << "La testa della Deque d1 e` " << d1.ReadHead() << endl;
  cout << "Rimuovo la testa di d1 " << d1.RemoveHead() << endl;
  cout << "La testa della Deque d1 e` " << d1.ReadHead() << endl;

  cout << "La coda della Deque d1 e` " << d1.ReadTail() << endl;
  cout << "Rimuovo la coda di d1 " << d1.RemoveTail() << endl;
  cout << "La coda della Deque d1 e` " << d1.ReadTail() << endl;

  if (d2.IsEmpty())
    cout << "La Deque d2 e` vuota." << endl;
  else {
    mytype testa = d2.RemoveHead();
    cout << "La testa di d2 era: " << testa << endl;
  }
}
